Rem Utility function to create a directory structure.
Rem  Difference between MKdir and MD is this function creates an entire structure.

Rem For example you could create \Temp\Newdir\Nextdir\

Dim Shared Current.Drive As String
Dim Shared NetPathError As Integer

' declare external libraries.
Declare Dynamic Library "kernel32"
   Function CreateDirectoryA% (F$, Byval X&&)
   Function GetLastError& ()
End Declare

Current.Drive = Left$(_CWD$, 1)

Print "Enter directory? ";
Input f$
If f$ <> "" Then
   x = CreateDirectoryStructure(f$)
   Color 14
   If x = 0 Then
      If NetPathError Then
         Print "Netpath error."
      Else
         Print "Error 0x" + Hex$(GetLastError) + " creating directory."
      End If
   Else
      Print "Directory created."
   End If
End If
Color 7
End

' routine to create directory structure
Function CreateDirectoryStructure (NewDirectory$)
   ' construct path
   NewDirectory$ = RTrim$(NewDirectory$)
   Next.Dest.Net$ = ""
   NetPathError = 0
   If Left$(NewDirectory$, 2) = "\\" Then ' \\serve\share\
      V = InStr(3, NewDirectory$, "\")
      If V Then
         V = InStr(V + 1, NewDirectory$, "\")
         If V Then
            Next.Dest.Net$ = Left$(NewDirectory$, V - 1)
            NewDirectory$ = Mid$(NewDirectory$, V + 1)
         End If
      End If
      If Next.Dest.Net$ = "" Then
         NetPathError = -1
         CreateDirectory = 0
         Exit Function
         NewDirectory$ = "\"
         Drive.Create$ = Current.Drive
      End If
   Else
      If Mid$(NewDirectory$, 2, 1) = ":" Then ' c:\tempx
         Drive.Create$ = Left$(NewDirectory$, 1)
         NewDirectory$ = Mid$(NewDirectory$, 3)
      Else
         If Left$(NewDirectory$, 1) = "\" Then ' \tempx
            Drive.Create$ = Left$(_CWD$, 1)
         Else
            If Left$(_CWD$, 2) = "\\" Then ' \\tempx
               Next.Dest.Net$ = _CWD$
            Else
               Drive.Create$ = Left$(_CWD$, 1) ' c:tempx
            End If
         End If
      End If
   End If
   If Right$(NewDirectory$, 1) <> "\" Then
      NewDirectory$ = NewDirectory$ + "\"
   End If

   ' create path
   x = 0
   Next.Dir = InStr(NewDirectory$, "\")
   Do
      If Next.Dir = False Then
         Exit Do
      End If

      ' parse path left to right
      SubDir$ = Left$(NewDirectory$, Next.Dir - 1) ' \tempx\t1\t2\t3\
      Next.Dir = InStr(Next.Dir + 1, NewDirectory$, "\")

      ' make directory name
      If Len(SubDir$) Then
         ' create directory
         If Len(Next.Dest.Net$) Then
            F$ = Next.Dest.Net$ + "\" + SubDir$
         Else
            F$ = Drive.Create$ + ":" + SubDir$
         End If

         ' check directory
         If _DirExists(F$) = 0 Then
            F$ = F$ + Chr$(0)
            x = CreateDirectoryA(F$, 0)

            ' check error
            If x = 0 Then
               If GetLastError& = &HB7 Then ' ignore already exists
                  ' nul
               Else
                  Exit Do
               End If
            End If
         End If
      End If
   Loop
   CreateDirectoryStructure = x
End Function

